<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from cookbook.texi on 28 April 1999 -->

<TITLE>The SUIF COOKBOOK - Example 4</TITLE>
<link href="cookbook_6.html" rel=Next>
<link href="cookbook_4.html" rel=Previous>
<link href="cookbook_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="cookbook_1.html">first</A>, <A HREF="cookbook_4.html">previous</A>, <A HREF="cookbook_6.html">next</A>, <A HREF="cookbook_8.html">last</A> section, <A HREF="cookbook_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC21" HREF="cookbook_toc.html#TOC21">Example 4 - Print Dependence Vectors</A></H1>

<P>
At each outermost loop nest, this pass will print all the true, anti and
output dependence vectors for each array write access.

</P>


<H2><A NAME="SEC22" HREF="cookbook_toc.html#TOC22">prog4.cc</A></H2>

<PRE>
#include &#60;stdlib.h&#62;
#include &#60;suif1.h&#62;
#include &#60;useful.h&#62;
#include &#60;dependence.h&#62;

/***************************************************************************
 * Declare a new class which is a list of "in_array"'s                     *
 ***************************************************************************/
DECLARE_DLIST_CLASS(array_instr_list, in_array *);

void find_array_instr(tree_node_list * tnl, array_instr_list * ail);
void find_array_instr(tree_node * tn, array_instr_list * ail);
void find_array_instr(instruction * i, array_instr_list * ail);

/***************************************************************************
 *
 ***************************************************************************/
void print_dep(in_array * ai1, in_array * ai2)
{
    dvlist * dep = DependenceTest(ai1, ai2);
    assert(dep);
    if(!dep-&#62;indep()) 
        dep-&#62;print(stdout);
}

/***************************************************************************
 *
 ***************************************************************************/
void process_array_instr_list(array_instr_list * ail) 
{
    array_instr_list_iter iter1(ail);
    while(!iter1.is_empty()) {
        in_array * ai1 = iter1.step();
        if(is_lhs(ai1)) {
            var_sym * vs1 = get_sym_of_array(ai1);
            print_array_access(ai1);
            printf("Output\n");
            print_dep(ai1, ai1);

            printf("True/anti\n");
            array_instr_list_iter iter2(ail);
            while(!iter2.is_empty()) {
                in_array * ai2 = iter2.step();
                var_sym * vs2 = get_sym_of_array(ai2);
                if(vs1 == vs2)
                    if(!is_lhs(ai2))
                        print_dep(ai1, ai2);
            }
        }
    }

    
}

/***************************************************************************
 * The main iterator over structured control-flow.                         *
 * When there is no outer for loop ail will be NULL.  ail will be assigned *
 * at the outermost for loops. All the array accesses are collected and    *
 * print routine is called at the outermost for loop.                      *
 ***************************************************************************/
void find_array_instr(tree_node_list * tnl, array_instr_list * ail)
{
    tree_node_list_iter iter(tnl);
    while(!iter.is_empty()) {
        tree_node * tn = iter.step();
        
        switch(tn-&#62;kind()) {
        case TREE_FOR:
            tree_for * tnf = (tree_for *)tn;
            find_array_instr(tnf-&#62;lb_list(), ail);
            find_array_instr(tnf-&#62;ub_list(), ail);
            find_array_instr(tnf-&#62;step_list(), ail);
            
            boolean outermost = FALSE;
            array_instr_list * ail_bdy = ail;
            if(ail_bdy == NULL) {
                outermost = TRUE;
                ail_bdy = new array_instr_list;
            }
            printf("For loop %s %s\n", 
                   tnf-&#62;index()-&#62;name(), 
                   outermost?"(Outermost)":"");
            
            find_array_instr(tnf-&#62;landing_pad(), ail_bdy);
            find_array_instr(tnf-&#62;body(), ail_bdy);
            
            if(outermost) process_array_instr_list(ail_bdy);
            break;
            
        case TREE_IF:
            tree_if * tni = (tree_if *)tn;
            find_array_instr(tni-&#62;header(), ail);
            find_array_instr(tni-&#62;then_part(), ail);
            find_array_instr(tni-&#62;else_part(), ail);
            break;
            
        case TREE_LOOP:
            tree_loop * tnl = (tree_loop *)tn;
            find_array_instr(tnl-&#62;body(), ail);
            find_array_instr(tnl-&#62;test(), ail);
            break;
            
        case TREE_BLOCK:
            tree_block * tnb = (tree_block *)tn;
            find_array_instr(tnb-&#62;body(), ail);
            break;
            
        case TREE_INSTR:
            tree_instr * tnin = (tree_instr *)tn;
            if(ail)
                find_array_instr(tnin-&#62;instr(), ail);
            break;
            
        default:
            assert(0);
            break;
        }
    }
}

/***************************************************************************
 * Iterate over all the instructions of expression trees, add array        *
 * instructions to the list.                                               *
 ***************************************************************************/
void find_array_instr(instruction * ins, array_instr_list * ail)
{
    if(ins-&#62;opcode() == io_array) {
        assert(ail);
        in_array * ia = (in_array *)ins;
        ail-&#62;append(ia);
    }

    for(int i=0; i&#60;ins-&#62;num_srcs(); i++) {
        operand op(ins-&#62;src_op(i));
        if(op.is_instr())
            find_array_instr(op.instr(), ail);
    }
}

/***************************************************************************
 * create the annotations needed by dependence by calling fill_in_access   *
 * And start processing..                                                  *
 ***************************************************************************/
void do_proc(tree_proc * tp)
{
    proc_sym * psym = tp-&#62;proc();
    printf("=======%s======= \n", psym-&#62;name());
    fill_in_access(tp);
    find_array_instr(tp-&#62;body(), NULL);
}

/***************************************************************************
 * Initialize and iterate over all the procedures.                         *
 ***************************************************************************/
main(int argc, char * argv[])
{        
    start_suif(argc, argv);
    suif_proc_iter(argc, argv, do_proc);
}
</PRE>

<P>
<A NAME="IDX109"></A>
<A NAME="IDX110"></A>
<A NAME="IDX111"></A>
<A NAME="IDX112"></A>
<A NAME="IDX113"></A>
<A NAME="IDX114"></A>
<A NAME="IDX115"></A>
<A NAME="IDX116"></A>
<A NAME="IDX117"></A>
<A NAME="IDX118"></A>
<A NAME="IDX119"></A>
<A NAME="IDX120"></A>
<A NAME="IDX121"></A>
<A NAME="IDX122"></A>
<A NAME="IDX123"></A>
<A NAME="IDX124"></A>
<A NAME="IDX125"></A>
<A NAME="IDX126"></A>
<A NAME="IDX127"></A>
<A NAME="IDX128"></A>
<A NAME="IDX129"></A>
<A NAME="IDX130"></A>
<A NAME="IDX131"></A>
<A NAME="IDX132"></A>
<A NAME="IDX133"></A>
<A NAME="IDX134"></A>
<A NAME="IDX135"></A>
<A NAME="IDX136"></A>
<A NAME="IDX137"></A>
<A NAME="IDX138"></A>
<A NAME="IDX139"></A>
<A NAME="IDX140"></A>
<A NAME="IDX141"></A>
<A NAME="IDX142"></A>
<A NAME="IDX143"></A>
<A NAME="IDX144"></A>
<A NAME="IDX145"></A>
<A NAME="IDX146"></A>
<A NAME="IDX147"></A>
<A NAME="IDX148"></A>
<A NAME="IDX149"></A>
<A NAME="IDX150"></A>
<A NAME="IDX151"></A>
<A NAME="IDX152"></A>
<A NAME="IDX153"></A>
<A NAME="IDX154"></A>
<A NAME="IDX155"></A>
<A NAME="IDX156"></A>
<A NAME="IDX157"></A>
<A NAME="IDX158"></A>
<A NAME="IDX159"></A>
<A NAME="IDX160"></A>
<A NAME="IDX161"></A>
<A NAME="IDX162"></A>
<A NAME="IDX163"></A>
<A NAME="IDX164"></A>
<A NAME="IDX165"></A>
<A NAME="IDX166"></A>
<A NAME="IDX167"></A>
<A NAME="IDX168"></A>
<A NAME="IDX169"></A>
<A NAME="IDX170"></A>
<A NAME="IDX171"></A>
<A NAME="IDX172"></A>
<A NAME="IDX173"></A>
<A NAME="IDX174"></A>

</P>
<P>
<A NAME="IDX175"></A>
<A NAME="IDX176"></A>
<A NAME="IDX177"></A>
<A NAME="IDX178"></A>
<A NAME="IDX179"></A>
<A NAME="IDX180"></A>
<A NAME="IDX181"></A>
<A NAME="IDX182"></A>
<A NAME="IDX183"></A>

</P>
<P>
The makefile is the same as the previous example.

</P>



<H2><A NAME="SEC23" HREF="cookbook_toc.html#TOC23">Testing the pass</A></H2>
<P>
Let's use the following input file:

</P>


<H3><A NAME="SEC24" HREF="cookbook_toc.html#TOC24">input4.c</A></H3>

<PRE>
double A[10000];
double B[100][100];

test1(int IU, int JU, int KU)
{
    int i, j, k;
    for(i=0; i&#60;IU; i++) 
        for(j=0; j&#60;JU; j++) {
            for(k=8; k&#60;KU; k++) 
                A[k] = A[k-8];
            B[i][j] = B[i+1][j] + A[i];
        }
    for(i=0; i&#60;IU; i++) 
        for(j=0; j&#60;JU; j++) 
            B[i][j] = B[i][j] + B[i+1][j];
}

test2( int KU)
{
    int  k;

    for(k=8; k&#60;KU; k++) 
        A[k] = A[1] + A[k] + A[k+8];
}
</PRE>



<H3><A NAME="SEC25" HREF="cookbook_toc.html#TOC25">Test session</A></H3>

<PRE>
csh&#62; prog4 input4.spd
=======test1=======
For loop i (Outermost)
For loop j
For loop k
A[k]
Output
( + * 0 )
( 0 + 0 )
( 0 0 0 )
True/anti
( + * -8 )
( 0 + -8 )
( + * + )
( + * 0 )
( + * - )
( 0 + + )
( 0 0 + )
( 0 + 0 )
( 0 0 0 )
( 0 + - )
B[i,j]
Output
( 0 0 )
True/anti
( 1 0 )
For loop i (Outermost)
For loop j
B[i,j]
Output
( 0 0 )
True/anti
( 0 0 )
( 1 0 )
=======test2=======
For loop k (Outermost)
A[k]
Output
( 0 )
True/anti
( 0 )
( 8 )
csh&#62;
</PRE>

<P><HR><P>
<p>Go to the <A HREF="cookbook_1.html">first</A>, <A HREF="cookbook_4.html">previous</A>, <A HREF="cookbook_6.html">next</A>, <A HREF="cookbook_8.html">last</A> section, <A HREF="cookbook_toc.html">table of contents</A>.
</BODY>
</HTML>
